function [xs, ys] = init_shapes(iprob);

if (iprob == 1)
  load channel.dat;
  alpha = channel(1,1);
  width = channel(1,2);
  sx = channel(2,1);
  sy = channel(2,2);
  sz = sx + sqrt(-1)*sy;
  z = [-20;20] + sqrt(-1)*[width;width];
  w1 = z*exp(sqrt(-1)*alpha) + sz;
  w2 = conj(z)*exp(sqrt(-1)*alpha) + sz;
  w = [w1 w2];
  xs = real(w);
  ys = imag(w);
elseif (iprob == 2)
  load annulus.dat;
  r1 = annulus(1,1);
  r2 = annulus(1,2);
  n_circles = 2;
  center = annulus(2,:);
  t = (-pi:2*pi/1500:pi)';
  x = r1*cos(t) + center(1);
  y = r1*sin(t) + center(2);
  xs = x;
  ys = y;
  % plot(x,y);
  x = r2*cos(t) + center(1);
  y = r2*sin(t) + center(2);
  xs = [xs x];
  ys = [ys y];
elseif (iprob == 3)
  load(['irr/xk']);
  load(['irr/yk']);
  [n,mbodies2]= size(xk);
  mbodies = mbodies2/2;
  xs = [];
  ys = [];
  for i = 1:mbodies,
    xkm = xk(:,2*i-1) + sqrt(-1)*xk(:,2*i);
    ykm = yk(:,2*i-1) + sqrt(-1)*yk(:,2*i);
    x = ifft(xkm*n);
    y = ifft(ykm*n);
    [xsv,ysv] = make_smooth(x,y);
    xs = [xs xsv];
    ys = [ys ysv];
  end;
elseif (iprob == 4)
  fprintf('init_shapes : No user supplied function for plotting shapes\n');
  xs = [];
  ys = [];
end;
